require 'flashsdk'

module SproutPunk
  module Assets
    class Asset
      attr_accessor :source_file, :class_name

      def initialize(source_file, class_name)
        @source_file = source_file
        @class_name = class_name
      end
    end

    class ClassGenerator < FlashSDK::ClassGenerator
      def initialize
        super
        @assets = []
      end

      def manifest
        @assets << Asset.new('../assets/ghoul.png', 'GHOUL_SPRITE')
        @assets << Asset.new('../assets/cone.png', 'CONE_SPRITE')
        @assets << Asset.new('../assets/friendly.png', 'FRIENDLY_SPRITE')
        @assets << Asset.new('../assets/priest.png', 'PRIEST_SPRITE')

        puts 'asset list:'
        @assets.each do |asset|
          puts "#{asset.class_name} -- #{asset.source_file}"
        end

        template "Assets.as", 'FlashpunkAssetsClass.as'
      end
    end
  end
end

=begin
namespace :sp do
  namespace :assets do
    desc "remove generated Assets.as file"
    task :clean do
    end

    desc "compile assets into Assets.as file"
    task :compile do
      generator = SproutPunk::Assets::ClassGenerator.new
      generator.parse! ARGV
      generator.execute
    end
  end

  task :assets => ["assets:clean", "assets:compile"]
end
=end
