require 'thor'
require 'thor/actions'
require 'thor/group'
require 'sproutpunk/commands/base'

module SproutPunk
  class CLI < Commands::Base
    default_task :help

    desc "start [env, ...]", "start the specified environment"
    def start(*envs)
      envs.each do |name|
        src = _config.builds.send(name)
        if src
          say "starting #{name}", :green
          mxmlc "bin/#{name}.swf" do |t|
            t.source_path << "lib"
            t.input = src
          end

          flashplayer :run => "bin/#{name}.swf"

          system "bundle exec rake run"
          #Rake.application["bin/#{name}.swf"].invoke
        end
      end
      exit
    end

    desc "setup [path]", "setup the SproutPunk gem (using an optional sproutpunk.yml file)"
    def setup
    end
  end

end

# require all commands
Dir[File.join(File.dirname(__FILE__), 'commands', "*.rb")].each {|file|
  load File.expand_path(file)
}
