module SproutPunk
  module Commands
    class Builds < Base
      command_set "builds", "builds [task]", "execute various build related commands"

      default_task :help

      desc "builds list", "show the current list of builds"
      def list
        if !_config.builds || !_config.builds.directory || !_config.builds.manifest
          say "I don't know where to find your Actionscript files or the build manifest."
          say "Please run `fp setup`."
          exit
        end

        print_table _config.builds.to_hash, :ident => 2
      end

      desc "builds add [name] [source]", "add a new build"
      def add(name, source)
        _manifest.send("#{name}=", source)
      end


      desc "builds remove [name]", "remove a build"
      def remove
        _manifest.delete(name)
      end

      desc "builds compile [target]", "compile all of the build targets to SWF files / AIR applications"
      def compile(target)
        build = SproutPunk::Builds::Build.new(target)
        build.execute
      end

    private
      def _manifest
        @_manifest ||= ConfigFile.load(_config.builds.manifest)
      end
    end
  end
end
